----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:26:01 10/25/2010 
-- Design Name: 
-- Module Name:    FIFO_control - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity FIFO_control is
	generic 
				(
				system_speed 	: integer := 133000000						-- Clock = 133MHz
				);
	port 
				(
				RESET						: in std_logic;						-- asynchroner Reset
				clk_i						: in std_logic;							
				clk90_i					: in std_logic;
				init_done				: in std_logic;							
				command_register		: out std_logic_vector(2 downto 0);
				input_adress			: out std_logic_vector(24 downto 0);
				cmd_ack					: in std_logic;
				input_data				: out std_logic_vector(31 downto 0)
				); 
end FIFO_control;

architecture Behavioral of FIFO_control is

type STATE_TYPE is 
		(
			INIT,
			RECEIVE
		);
		
signal STATE	: STATE_TYPE := INIT;
signal counter	: natural range 0 to 33500 := 33500;
signal timer 	:natural range 0 to 33400 := 33400;	

begin

FIFO_control : process(clk_i, clk90_i)
	begin
		if falling_edge(clk_i) then
			if RESET = '1' then
				STATE <= INIT;
			else
				case STATE is
					when INIT =>
						if counter = 0 then
							STATE <= RECEIVE;
							command_register <= "010";
							else 
							command_register <= "000";
							counter <= counter - 1;
						end if;
					when RECEIVE =>
						command_register <= "000";
						if init_done = '1' and falling_edge(clk_i) then
							command_register <= "100";
							input_adress <= "0000000000000000000000000";
						end if;
						if cmd_ack = '1' then
							--if rising_edge(clk90_i) then
								input_data <= "10010010010010011001001001001001";
							--end if;
						end if;
							
							
						
				end case;
			end if;
		end if;
			
			
	end process;		
end Behavioral;
















