----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    08:51:28 09/09/2010 
-- Design Name: 
-- Module Name:    and - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.all;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

Library WORK;
use WORK.all;

Library UNISIM;
use UNISIM.vcomponents.all;


---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity main is
	 Generic	(
				system_speed	: integer := 133000000;		-- Taktrate Systemtakt in Hz
				bitrate			: integer := 1000000			-- Bitrate Differentielle Schnittstelle
				);
    Port 	(
				RESET 			: in std_logic;				
				CLK_50M 			: in std_logic;
				CLK_AUX 			: in std_logic;
				CLK_SMA 			: in std_logic;
				--CLK_AUX_P		: out std_logic;
				--CLK_AUX_N		: out std_logic;
				-- Discrete Indicators (LED)
				LED 				: out std_logic_vector(7 downto 0) := (others => '0');
				-- Character Display (LCD)
				LCD_DB 			: out std_logic_vector(7 downto 0) := (others => '0');
				LCD_E 			: out std_logic := '0';
				LCD_RS 			: out std_logic := '0';
				LCD_RW 			: out std_logic := '0';
				-- Stereo Audio Output (AUD)
--				AUD_L 			: out std_logic := '0';
--				AUD_R 			: out std_logic := '0';
				-- Video Output Port (VGA)
--				VGA_B 			: out std_logic_vector(3 downto 0) := (others => '0');
--				VGA_G 			: out std_logic_vector(3 downto 0) := (others => '0');
--				VGA_R 			: out std_logic_vector(3 downto 0) := (others => '0');
--				VGA_HSYNC 		: out std_logic := '0';
--				VGA_VSYNC 		: out std_logic := '0';
				-- Hirose Expansion Connector (FX2)
--				FX2_IO 			: out std_logic_vector(40 downto 0) := (others => '0');
--				FX2_CLKIN 		: in std_logic := '0';
--				FX2_CLKIO 		: out std_logic := '0';
--				FX2_CLKOUT 		: out std_logic := '0';
				-- Accessory Headers (J18, J19, J20)
--				J18_IO 			: out  std_logic_vector(4 downto 0) := (others => '0');
--				J19_IO 			: out std_logic_vector(4 downto 0) := (others => '0');
--				J20_IO 			: out std_logic_vector(4 downto 0) := (others => '0');
				-- Mouse and/or Keyboard Connector (PS2)
--				PS2_CLK1 		: in std_logic := '0';
--				PS2_DATA1 		: in std_logic := '0';
--				PS2_CLK2 		: in std_logic := '0';
--				PS2_DATA2 		: in std_logic := '0';
			 	-- High-Speed LVDS Receiver Connector (RX)
			  	RX_CLK_N : in std_logic := '0';
			  	RX_CLK_P : in std_logic := '0';
				
			  	RX_N : in std_logic_vector(4 downto 0) := (others => '0');
			  	RX_P : in std_logic_vector(4 downto 0) := (others => '0');
				
					-- High-Speed LVDS Transmitter Connector (TX)
			  	TX_CLK_N : out std_logic := '0';
			  	TX_CLK_P : out std_logic := '0';
			  	TX_N : out std_logic_vector(4 downto 0) := (others => '0');
				TX_P : out std_logic_vector(4 downto 0) := (others => '0');
				--Directional Push-Buttons (BTN)
				BTN_EAST 		: in std_logic := '0';
				BTN_NORTH 		: in std_logic := '0';
				BTN_SOUTH 		: in std_logic := '0';
				BTN_WEST 		: in std_logic := '0';
				-- Rotary Knob (ROT)
				ROT_CENTER 		: in std_logic := '0';
				ROT_A 			: in std_logic := '0';
				ROT_B 			: in std_logic := '0';
				-- Mechanical Switches (SW)
				SW 				: in std_logic_vector(3 downto 0) := (others => '0');
				-- Serial Ports (RS232)
				RS232_DCE_RXD 	: in std_logic:= '0';			
				RS232_DCE_TXD 	: out std_logic := '1';			
				
				RS232_DTE_RXD 	: in std_logic := '0';
				RS232_DTE_TXD 	: out std_logic := '0';		  		  	  
				-- Regulator I2C Control (REG)
						-- Controls VCCINT, VCCAUX, and VCCO_012 supply rails.
				REG1_SCL 		: in std_logic := '0';
				REG1_SDA 		: in std_logic := '0';
						-- Controls SDRAM, TERM, and VREF supply rails.
				REG2_SCL 		: in std_logic := '0';
				REG2_SDA 		: in std_logic := '0';
				-- 10/100 Ethernet (E)
--				E_TX_CLK 		: in std_logic := '0';
--				E_RX_CLK 		: in std_logic := '0';
--				E_NRST 			: in std_logic := '0';
--				E_MDC 			: in std_logic := '0';
--				E_MDIO 			: in std_logic := '0';
--				E_TXD 			: out std_logic_vector(3 downto 0) := (others => '0');
--				E_TX_EN 			: in std_logic := '0';
--				E_RXD 			: in std_logic_vector(3 downto 0) := (others => '0');
--				E_RX_DV 			: in std_logic := '0';
--				E_RX_ERR 		: in std_logic := '0';
--				E_NINT 			: in std_logic := '0';
--				E_CRS 			: in std_logic := '0';
--				E_COL 			: in std_logic := '0';
				-- Serial Peripheral System
				SPI_SCK 			: in std_logic := '0';
				SPI_MOSI 		: in std_logic := '0';
				SPI_MISO 		: in std_logic := '0'; 
				AMP_OUT 			: in std_logic := '0';
				DAC_OUT 			: in std_logic := '0';
				ADC_OUT 			: in std_logic := '0';
				SPI_SS_B 		: in std_logic := '0';
				ALT_SS_B 		: in std_logic := '0';
				FPGA_INIT_B 	: in std_logic := '0';
				AMP_CS 			: in std_logic := '0';
				DAC_CS 			: in std_logic := '0';
				AD_CONV 			: in std_logic := '0';
				AMP_SHDN 		: in std_logic := '0';
				DAC_CLR 			: in std_logic := '0';
				ST_SPI_WP 		: in std_logic := '0';
				DATAFLASH_WP 	: in std_logic := '0';
				DATAFLASH_RST 	: in std_logic := '0';
				-- Parallel Flash (NF)
				NF_CE 			: in std_logic := '0';
				NF_BYTE 			: in std_logic := '0';
				NF_OE 			: in std_logic := '0';
				NF_RP 			: in std_logic := '0';
				NF_WE 			: in std_logic := '0';
				NF_WP 			: in std_logic := '0';
				NF_STS 			: in std_logic := '0';
				NF_A 				: in std_logic_vector(21 downto 0) := (others => '0');
				NF_D 				: in std_logic_vector(21 downto 0) := (others => '0');
				-- DDR2 SDRAM Device (SD)
				cntrl0_ddr2_a			: out std_logic_vector(12 downto 0) := (others => '0');
				cntrl0_ddr2_ba			: out std_logic_vector(1 downto 0)  := (others => '0');
				cntrl0_ddr2_ck			: out std_logic_vector(0 downto 0) := (others => '0');
				cntrl0_ddr2_ck_n		: out std_logic_vector(0 downto 0) := (others => '0');
				cntrl0_ddr2_cke		: out std_logic := '0';
				cntrl0_ddr2_cs_n		: out std_logic := '0';
				cntrl0_ddr2_ras_n 	: out std_logic := '0';
				cntrl0_ddr2_cas_n 	: out std_logic := '0';
				cntrl0_ddr2_we_n 		: out std_logic := '0';
				cntrl0_ddr2_odt 		: out std_logic := '0';
				cntrl0_ddr2_dm 		: out std_logic_vector(1 downto 0) := (others => '0');
				cntrl0_ddr2_dqs_n		: inout std_logic_vector(1 downto 0) := (others => '0');
				cntrl0_ddr2_dqs	 	: inout std_logic_vector(1 downto 0) := (others => '0');
				cntrl0_ddr2_dq			: inout std_logic_vector(15 downto 0) := (others => '0')
				);
			  
end main;

architecture Behavioral of main is

-- Clocksignalleitung
signal CLK_AUX_P					: std_logic;
signal CLK_AUX_N					: std_logic;
signal CLK_AUX_i					: std_logic;
signal CLK_50M_i					: std_logic;
signal RESET_N						: std_logic;
signal RESET_i						: std_logic;
-- Differentielle Inputsignalleitungen
--signal Buff_in_CLK				: std_logic;
signal Buff_In		: std_logic_vector(4 downto 0);
--signal Buff_In1 					: std_logic;
--signal Buff_In2 					: std_logic;
--signal Buff_In3 					: std_logic;
--signal Buff_In4 					: std_logic;
-- Differentielle Outputsignalleitungen
--signal Buff_Out_CLK				: std_logic;
signal Buff_Out	: std_logic_vector(4 downto 0);
--signal Buff_Out1 					: std_logic;
--signal Buff_Out2 					: std_logic;
--signal Buff_Out3 					: std_logic;
--signal Buff_Out4 					: std_logic;
-- Receivesignalleitungen
signal rec_timer_start_out_delay_start_in		: std_logic;
signal rec_valid_fb_out_delay_valid_fb_in		: std_logic;
signal rec_valid_sb_out_delay_valid_sb_in		: std_logic;
signal rec_valid_dat_out_6666666666				: std_logic;
signal rec_valid_out_delay_valid_in				: std_logic;
signal delay_valid_out_send_valid_in			: std_logic;
signal rec_bw_dat1_out_delay_bw_dat1_in		: std_logic_vector(15 downto 0);
signal rec_bw_dat2_out_delay_bw_dat2_in		: std_logic_vector(15 downto 0);
signal bitwise_data1_out							: std_logic_vector(15 downto 0);
signal bitwise_data2_out							: std_logic_vector(15 downto 0);
signal rec_dat_out_delay_dat_in					: std_logic_vector(15 downto 0);
signal dat_delay_out_dat_send_in					: std_logic_vector(15 downto 0);
-- DDR2 SDRAM-Leitungen
signal clk_tb											: std_logic;
signal clk90_tb										: std_logic;
signal burst_done 									: std_logic;
signal user_command_register						: std_logic_vector(2 downto 0);
signal user_data_mask								: std_logic_vector(3 downto 0);
signal user_input_data								: std_logic_vector(31 downto 0);
signal user_input_address							: std_logic_vector(24 downto 0);
signal init_done										: std_logic;
signal ar_done											: std_logic;
signal auto_ref_req									: std_logic;
signal user_cmd_ack									: std_logic;
signal user_data_valid								: std_logic;
signal user_output_data								: std_logic_vector(31 downto 0);

signal rst_dqs_div_in		 						: std_logic;
signal rst_dqs_div_out		 						: std_logic;

component Receive is
		generic 
				(
				system_speed 			: integer := 50000000;					-- Clock = 50MHz
				bitrate 	 				: integer := 1000000						-- Bitrate = 1Mbit/s (spter variabel)
				);
		port 	
				(
				RESET						: in std_logic;							-- asynchroner Reset
				clk_i						: in std_logic;							-- Clock fr Receive (50MHz)
				init_done_i				: in std_logic;							-- Initialisierungssignal des spteren DDR2-Rams
				timer_start				: out std_logic;
				rx							: in std_logic;							-- Empfangsping
				valid_first_bitwise	: out std_logic := '0';					-- Datenvektor "bitwise_dat1_out" ist gltig
				valid_scnd_bitwise	: out std_logic := '0';					-- Datenvektor "bitwise_dat2_out" ist gltig
				valid_data				: out std_logic;							-- Datenvektor "dat_out" ist gltig
				valid						: out std_logic;							-- es liegen Daten an rx an
				bitwise_dat1_out		: out std_logic_vector(15 downto 0) := (others => '0');-- Datenvektor der jedes einzelne Bit ausgibt
				bitwise_dat2_out		: out std_logic_vector(15 downto 0) := (others => '0');-- Datenvektor der jedes einzelne Bit ausgibt
				dat_out					: out std_logic_vector(15 downto 0)	-- Datenvektor fr komplette 32 Bit
				); 
end component Receive;

component Delay is
	generic 
		(
		system_speed 	: integer := 50000000;						-- System Speed in Hz
		bitrate 			: integer := 1000000;						-- Bitrate = 1Mbit/s (spter variabel)
		time_delay 		: integer := 2000
		);
	port
		(
		RESET							: in std_logic;							-- asynchroner Reset
		clk_i							: in std_logic;							-- Clock fr Receive (50MHz)
		start							: in std_logic;
		valid							: in std_logic;
		valid_first_bitwise		: in std_logic;
		valid_scnd_bitwise		: in std_logic;
		valid_delay					: out std_logic;
		bitwise_dat1_delay_in	: in std_logic_vector(15 downto 0) := (others => '0');-- Datenvektor der jedes einzelne Bit ausgibt
		bitwise_dat2_delay_in	: in std_logic_vector(15 downto 0) := (others => '0');-- Datenvektor der jedes einzelne Bit ausgibt
		dat_delay_in				: in std_logic_vector(15 downto 0) := (others => '0');-- Datenvektor der jedes einzelne Bit ausgibt
		dat_delay_out				: out std_logic_vector(15 downto 0) := (others => '0')
		);
end component Delay;

component Send is
	generic
				(
				system_speed		: integer := 50000000;					-- Clock = 50MHz
				bitrate				: integer := 1000000						-- Bitrate = 1Mbit/s (spter variabel)
				);
	port
				(
				RESET					: in std_logic;  							-- asynchroner Reset
				clk_i					: in std_logic;  							-- Clock fr Send (50MHz)
				start					: in std_logic;
				tx						: out std_logic; 							-- Sendepin
				valid					: in std_logic;							-- Anzeige, dass Signale am Eingang sind
				dat_in				: in std_logic_vector(15 downto 0)	--	Datenwort-weise einlesen der rx daten
				);
end component Send;

component FIFO_control is
	generic 
				(
				system_speed 	: integer := 133000000						-- Clock = 133MHz
				);
	port 
				(
				RESET						: in std_logic;							-- asynchroner Reset
				clk_i						: in std_logic;							
				clk90_i					: in std_logic;
				init_done				: in std_logic;							
				command_register		: out std_logic_vector(2 downto 0);
				input_adress			: out std_logic_vector(24 downto 0);
				cmd_ack					: in std_logic;
				input_data				: out std_logic_vector(31 downto 0)
				); 
end component FIFO_control;


component FIFO is
	port
				(
				sys_clk_in                    : in    std_logic;
				reset_in_n                    : in    std_logic;
				cntrl0_burst_done             : in    std_logic;
				cntrl0_user_command_register  : in    std_logic_vector(2 downto 0);
				cntrl0_user_data_mask         : in    std_logic_vector(3 downto 0);
				cntrl0_user_input_data        : in    std_logic_vector(31 downto 0);
				cntrl0_user_input_address     : in    std_logic_vector(24 downto 0);
				cntrl0_init_done              : out   std_logic;
				cntrl0_ar_done                : out   std_logic;
				cntrl0_auto_ref_req           : out   std_logic;
				cntrl0_user_cmd_ack           : out   std_logic;
				cntrl0_clk_tb                 : out   std_logic;
				cntrl0_clk90_tb               : out   std_logic;
				cntrl0_sys_rst_tb             : out   std_logic;
				cntrl0_sys_rst90_tb           : out   std_logic;
				cntrl0_sys_rst180_tb          : out   std_logic;
				cntrl0_user_data_valid        : out   std_logic;
				cntrl0_user_output_data       : out   std_logic_vector(31 downto 0);
				
				cntrl0_ddr2_ras_n             : out   std_logic;
				cntrl0_ddr2_cas_n             : out   std_logic;
				cntrl0_ddr2_we_n              : out   std_logic;
				cntrl0_ddr2_cs_n              : out   std_logic;
				cntrl0_ddr2_cke               : out   std_logic;
				cntrl0_ddr2_dm                : out   std_logic_vector(1 downto 0);
				cntrl0_ddr2_ba                : out   std_logic_vector(1 downto 0);
				cntrl0_ddr2_a                 : out   std_logic_vector(12 downto 0);
				cntrl0_ddr2_ck                : out   std_logic_vector(0 downto 0);
				cntrl0_ddr2_ck_n              : out   std_logic_vector(0 downto 0);
				cntrl0_ddr2_dqs               : inout std_logic_vector(1 downto 0);
				cntrl0_ddr2_dqs_n             : inout std_logic_vector(1 downto 0);
				cntrl0_ddr2_dq                : inout std_logic_vector(15 downto 0);
				cntrl0_ddr2_odt               : out   std_logic;
				
				cntrl0_rst_dqs_div_in         : in    std_logic;
				cntrl0_rst_dqs_div_out        : out   std_logic			
				);
end component FIFO;

begin	

--	BUFG_INST1 : IBUFG
--	port map 
--				(
--					O => CLK_AUX_i,     		-- Clock buffer output
--					I => CLK_AUX      -- Clock buffer input
--				);

	BUFG_INST2 : IBUFG
	port map 
				(
					O => CLK_50M_i,     		-- Clock buffer output
					I => CLK_50M      -- Clock buffer input
				);

-- DIFFERENZIELLER INPUT
	
--	IBUFDSCLK_inst : IBUFDS
--   generic map 
--				(
--					DIFF_TERM => FALSE, -- Differential Termination
--					IBUF_DELAY_VALUE => "0", -- Specify the amount of added input delay for buffer, "0"-"16" 
--					IFD_DELAY_VALUE => "AUTO", -- Specify the amount of added delay for input register, "AUTO", "0"-"8" 
--					IOSTANDARD => "DEFAULT"
--				)
--   port map 
--				(
--					O 	=>	Buff_Out_CLK,  	-- Buffer output
--					I 	=> RX_CLK_N,  		-- Diff_p buffer input (connect directly to top-level port)
--					IB => RX_CLK_P 			-- Diff_n buffer input (connect directly to top-level port)
--				);	
	
	IBUFDS0_inst : IBUFDS
   generic map 
				(
					DIFF_TERM => FALSE, -- Differential Termination
					IBUF_DELAY_VALUE => "0", -- Specify the amount of added input delay for buffer, "0"-"16" 
					IFD_DELAY_VALUE => "AUTO", -- Specify the amount of added delay for input register, "AUTO", "0"-"8" 
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=>	Buff_In(0),  	-- Buffer output
					I 	=> RX_P(0),  		-- Diff_p buffer input (connect directly to top-level port)
					IB => RX_N(0) 			-- Diff_n buffer input (connect directly to top-level port)
				);	
				
   IBUFDS1_inst : IBUFDS
   generic map 
				(
					DIFF_TERM => FALSE, -- Differential Termination
					IBUF_DELAY_VALUE => "0", -- Specify the amount of added input delay for buffer, "0"-"16" 
					IFD_DELAY_VALUE => "AUTO", -- Specify the amount of added delay for input register, "AUTO", "0"-"8" 
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=>	Buff_In(1),  	-- Buffer output
					I 	=> RX_P(1),  		-- Diff_p buffer input (connect directly to top-level port)
					IB => RX_N(1) 			-- Diff_n buffer input (connect directly to top-level port)
				);				
	
	IBUFDS2_inst : IBUFDS
   generic map 
				(
					DIFF_TERM => FALSE, -- Differential Termination
					IBUF_DELAY_VALUE => "0", -- Specify the amount of added input delay for buffer, "0"-"16" 
					IFD_DELAY_VALUE => "AUTO", -- Specify the amount of added delay for input register, "AUTO", "0"-"8" 
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=>	Buff_In(2),  	-- Buffer output
					I 	=> RX_P(2),  		-- Diff_p buffer input (connect directly to top-level port)
					IB => RX_N(2) 			-- Diff_n buffer input (connect directly to top-level port)
				);	

	IBUFDS3_inst : IBUFDS
   generic map 
				(
					DIFF_TERM => FALSE, -- Differential Termination
					IBUF_DELAY_VALUE => "0", -- Specify the amount of added input delay for buffer, "0"-"16" 
					IFD_DELAY_VALUE => "AUTO", -- Specify the amount of added delay for input register, "AUTO", "0"-"8" 
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=>	Buff_In(3),  	-- Buffer output
					I 	=> RX_P(3),  		-- Diff_p buffer input (connect directly to top-level port)
					IB => RX_N(3) 			-- Diff_n buffer input (connect directly to top-level port)
				);

	IBUFDS4_inst : IBUFDS
   generic map 
				(
					DIFF_TERM => FALSE, -- Differential Termination
					IBUF_DELAY_VALUE => "0", -- Specify the amount of added input delay for buffer, "0"-"16" 
					IFD_DELAY_VALUE => "AUTO", -- Specify the amount of added delay for input register, "AUTO", "0"-"8" 
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=>	Buff_In(4),  	-- Buffer output
					I 	=> RX_P(4),  		-- Diff_p buffer input (connect directly to top-level port)
					IB => RX_N(4) 			-- Diff_n buffer input (connect directly to top-level port)
				);


--DIFFERENTIELLER OUTPUT
	
--	OBUFDSCLK_inst : OBUFDS
--   generic map 
--				(
--					IOSTANDARD => "DEFAULT"
--				)
--   port map 
--				(
--					O 	=> TX_CLK_P,     		-- Diff_p output (connect directly to top-level port)
--					OB => TX_CLK_N,  			-- Diff_n output (connect directly to top-level port)
--					I 	=> Buff_In_CLK      	-- Buffer input 
--				);
	
	OBUFDS0_inst : OBUFDS
   generic map 
				(
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=> TX_P(0),     		-- Diff_p output (connect directly to top-level port)
					OB => TX_N(0),  			-- Diff_n output (connect directly to top-level port)
					I 	=> Buff_Out(0)      	-- Buffer input 
				);
			
	OBUFDS1_inst : OBUFDS
   generic map 
				(
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=> TX_P(1),     		-- Diff_p output (connect directly to top-level port)
					OB => TX_N(1),  			-- Diff_n output (connect directly to top-level port)
					I 	=> Buff_Out(1)      	-- Buffer input 
				);

	OBUFDS2_inst : OBUFDS
   generic map 
				(
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=> TX_P(2),     		-- Diff_p output (connect directly to top-level port)
					OB => TX_N(2),  			-- Diff_n output (connect directly to top-level port)
					I 	=> Buff_Out(2)      	-- Buffer input 
				);
				
	OBUFDS3_inst : OBUFDS
   generic map 
				(
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=> TX_P(3),     		-- Diff_p output (connect directly to top-level port)
					OB => TX_N(3),  			-- Diff_n output (connect directly to top-level port)
					I 	=> Buff_Out(3)      	-- Buffer input 
				);				
	
	OBUFDS4_inst : OBUFDS
   generic map 
				(
					IOSTANDARD => "DEFAULT"
				)
   port map 
				(
					O 	=> TX_P(4),     		-- Diff_p output (connect directly to top-level port)
					OB => TX_N(4),  			-- Diff_n output (connect directly to top-level port)
					I 	=> Buff_Out(4)      	-- Buffer input 
				);

	Receive_inst : Receive
	generic map 
				(
					system_speed 			=> 50000000,
					bitrate					=> 1000000
				)
	port map (
					RESET						=>	RESET_i,			
					clk_i						=> CLK_50M_i,
					init_done_i				=> init_done,
					timer_start				=> rec_timer_start_out_delay_start_in,
					rx							=> Buff_In(1),	
					valid_first_bitwise	=> rec_valid_fb_out_delay_valid_fb_in,
					valid_scnd_bitwise	=> rec_valid_sb_out_delay_valid_sb_in,
					valid_data				=> rec_valid_dat_out_6666666666,--#########################################
					valid						=> rec_valid_out_delay_valid_in,
					bitwise_dat1_out		=> rec_bw_dat1_out_delay_bw_dat1_in,
					bitwise_dat2_out		=> rec_bw_dat2_out_delay_bw_dat2_in,
					dat_out					=>	rec_dat_out_delay_dat_in			
				); 
	
	Delay_inst : Delay
	generic map
				(
				system_speed 				=> 50000000,						-- System Speed in Hz
				bitrate 						=> 1000000,						-- Bitrate = 1Mbit/s (spter variabel)
				time_delay 					=> 40000
				)
	port map
				(
				RESET							=> RESET_i,
				clk_i							=> CLK_50M_i,
				start							=> rec_timer_start_out_delay_start_in,
				valid							=> rec_valid_out_delay_valid_in,
				valid_first_bitwise		=>	rec_valid_fb_out_delay_valid_fb_in,
				valid_scnd_bitwise		=> rec_valid_sb_out_delay_valid_sb_in,
				valid_delay					=> delay_valid_out_send_valid_in,
				bitwise_dat1_delay_in	=> rec_bw_dat1_out_delay_bw_dat1_in,
				bitwise_dat2_delay_in	=> rec_bw_dat2_out_delay_bw_dat2_in,
				dat_delay_in				=> rec_dat_out_delay_dat_in,
				dat_delay_out				=> dat_delay_out_dat_send_in
				);
	
	Send_inst : Send
	generic map
				(
					system_speed			=> 50000000,
					bitrate					=> 1000000
				)
	port map
				(
					RESET						=> RESET_i,
					clk_i						=> CLK_50M_i,
					start						=> rec_timer_start_out_delay_start_in,
					tx							=>	Buff_Out(0),
					valid						=> delay_valid_out_send_valid_in,
					dat_in					=> dat_delay_out_dat_send_in
				);
	
	FIFO_control_inst : FIFO_control
	generic map
				(
				system_speed 				=> 133000000						-- Clock = 133MHz
				)
	port map
				(
				RESET							=> RESET_i,
				clk_i							=> clk_tb,
				clk90_i						=> clk90_tb,
				init_done					=> init_done,
				command_register			=> user_command_register,
				input_adress				=> user_input_address,
				cmd_ack						=> user_cmd_ack,
				input_data				 	=> user_input_data
				); 
	
	FIFO_INST : FIFO
	port map
				(
				sys_clk_in                    =>	CLK_AUX,
				reset_in_n                    => RESET_N,
				cntrl0_burst_done             => SW(1), --burst_done,
				cntrl0_user_command_register  => user_command_register,
				cntrl0_user_data_mask         => user_data_mask,
				cntrl0_user_input_data        => user_input_data,
				cntrl0_user_input_address     => user_input_address,
				cntrl0_init_done             	=> open,
				cntrl0_ar_done                => ar_done,
				cntrl0_auto_ref_req           => auto_ref_req,
				cntrl0_user_cmd_ack          	=> user_cmd_ack,
				cntrl0_clk_tb                 => clk_tb,
				cntrl0_clk90_tb              	=> clk90_tb,
				cntrl0_sys_rst_tb             => open,
				cntrl0_sys_rst90_tb           => open,
				cntrl0_sys_rst180_tb          => open,
				cntrl0_user_data_valid        => user_data_valid,
				cntrl0_user_output_data       => user_output_data,
				
				cntrl0_ddr2_ras_n             => cntrl0_ddr2_ras_n,
				cntrl0_ddr2_cas_n            	=> cntrl0_ddr2_cas_n,
				cntrl0_ddr2_we_n              => cntrl0_ddr2_we_n,
				cntrl0_ddr2_cs_n             	=> cntrl0_ddr2_cs_n,
				cntrl0_ddr2_cke              	=> cntrl0_ddr2_cke,
				cntrl0_ddr2_dm                => cntrl0_ddr2_dm,
				cntrl0_ddr2_ba               	=> cntrl0_ddr2_ba,
				cntrl0_ddr2_a                 => cntrl0_ddr2_a,
				cntrl0_ddr2_ck               	=> cntrl0_ddr2_ck,
				cntrl0_ddr2_ck_n             	=> cntrl0_ddr2_ck_n,
				cntrl0_ddr2_dqs              	=> cntrl0_ddr2_dqs,
				cntrl0_ddr2_dqs_n           	=> cntrl0_ddr2_dqs_n,
				cntrl0_ddr2_dq               	=> cntrl0_ddr2_dq,
				cntrl0_ddr2_odt               => cntrl0_ddr2_odt,		

				cntrl0_rst_dqs_div_in         => SW(2),--rst_dqs_div_in,
				cntrl0_rst_dqs_div_out        => rst_dqs_div_out
				);
	
	RESET_N 			<= not RESET_i;
	RESET_i			<=	SW(0);
	init_done		<= SW(3);
	LED(0)			<= init_done;
	LED(1)			<= '0';
	LED(2)			<= '0';
	LED(3)			<= '0';
	LED(4)			<= '0';
	LED(5)			<= '0';
	LED(6)			<= '0';
	LED(7)			<= '0';
	LCD_DB    		<= (others => '0');
	LCD_E     		<= '0';
	LCD_RS    		<= '0';
	LCD_RW    		<= '0';
--	AUD_L     		<= '0';
--	AUD_R     		<= '0';
--	VGA_B     		<= (others => '0');
--	VGA_G     		<= (others => '0');
--	VGA_R     		<= (others => '0');
--	VGA_HSYNC 		<= '0';
--	VGA_VSYNC 		<= '0';
--	FX2_IO			<= (others => '0');
--	FX2_CLKIO 		<= '0';
--	FX2_CLKOUT		<= '0';
--	J18_IO    		<= (others => '0');
--	J19_IO    		<= (others => '0');
--	J20_IO	 		<= (others => '0');
	RS232_DTE_TXD  <= '0';
	RS232_DCE_TXD  <= '0';
--	E_TXD				<= (others => '0');

end Behavioral;


