----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:44:43 10/12/2010 
-- Design Name: 
-- Module Name:    Send - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Send is
	generic
				(
				system_speed		: integer := 50000000;					-- Clock = 50MHz
				bitrate				: integer := 1000000						-- Bitrate = 1Mbit/s (spter variabel)
				);
	port
				(
				RESET					: in std_logic;  							-- asynchroner Reset
				clk_i					: in std_logic;  							-- Clock fr Send (50MHz)
				start					: in std_logic;
				tx						: out std_logic := '0'; 				-- Sendepin
				valid					: in std_logic;							-- Anzeige, dass Signale am Eingang sind
				dat_in				: in std_logic_vector(15 downto 0)	--	Datenwort-weise einlesen der rx daten
				);
end Send;

architecture Behavioral of Send is

constant max_counter: natural := system_speed / bitrate;
  
type STATE_TYPE is 
		(
		INIT,
		WAIT_FOR_START,
		SEND_BITS
		);

  signal STATE: STATE_TYPE := INIT;
  signal bitrate_counter: natural range 0 to max_counter := 0;	-- Downzhler zum beeitstellen der Lnge eines Bits
  signal bit_counter: natural range 0 to 15 := 0;					-- Zhlt, wieviel Bits gesendet wurden und fngt nach 32 von vorn an
  signal shift_register: std_logic_vector(15 downto 0) := (others => '0');			-- zum umwandeln des Vektors in einzelnen Bitstrom

begin


  -- acknowledge, when sending process was started

Send: process(clk_i)
	begin
		if rising_edge(clk_i) then
			if RESET = '1' then
				tx <= '0';
				STATE <= INIT;
			else				
				case STATE is
					-- COUNTERINITIALISIERUNGEN
					when INIT => 
						if start = '1' then
							STATE <= WAIT_FOR_START;
							
						end if;
						
					when WAIT_FOR_START =>
						if valid = '1' then	
							STATE <= SEND_BITS;
							--shift_register <= shift_register(30 downto 0) & '0';
							--shift_register <= dat_in;
							bitrate_counter <= max_counter - 1;
							bit_counter <= 15;
							--tx <= dat_in(0);
						end if;
					
					when SEND_BITS =>
						if bitrate_counter = 0 then
							if bit_counter = 0 then
								--tx <= dat_in(0);
								--shift_register <= dat_in;
								bit_counter <= 15;
							else
								shift_register <= dat_in;
								--tx <= dat_in(0);
								--tx <= shift_register(0);
								shift_register <= shift_register(14 downto 0) & '0';
								bit_counter <= bit_counter - 1;
							end if;
							tx <= dat_in(0);
							bitrate_counter <= max_counter - 1;
						else
							tx <= dat_in(0);
							bitrate_counter <= bitrate_counter - 1;
						end if;
							
	
				end case;
			end if;
		end if;
	end process;
end Behavioral;













